---
title: Function.prototype.toString()
slug: Web/JavaScript/Reference/Global_Objects/Function/toString
tags:
  - Function
  - JavaScript
  - Method
  - Prototype
---
<div>{{JSRef}}</div>

<p>The <code><strong>toString()</strong></code> method returns a string representing the source code of the function.</p>

<div>{{EmbedInteractiveExample("pages/js/function-tostring.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>function</var>.toString()</pre>

<h3 id="Return_value">Return value</h3>

<p>A string representing the source code of the function.</p>

<h2 id="Description">Description</h2>

<p>The {{jsxref("Function")}} object overrides the {{jsxref("Object.prototype.toString", "toString")}} method inherited from {{jsxref("Object")}}; it does not inherit {{jsxref("Object.prototype.toString")}}. For user-defined {{jsxref("Function")}} objects, the <code>toString</code> method returns a string containing the source text segment which was used to define the function.</p>

<p>JavaScript calls the <code>toString</code> method automatically when a {{jsxref("Function")}} is to be represented as a text value, e.g. when a function is concatenated with a string.</p>

<p>The <code>toString()</code> method will throw a {{jsxref("TypeError")}} exception ("Function.prototype.toString called on incompatible object"), if its <code>this</code> value object is not a <code>Function</code> object.</p>

<pre class="brush: js example-bad notranslate">Function.prototype.toString.call('foo'); // TypeError
</pre>

<p>If the <code>toString()</code> method is called on built-in function objects or a function created by <code>Function.prototype.bind</code>, <code>toString()</code> returns a <em>native function string</em> which looks like</p>

<pre class="brush: js notranslate">"function () {\n    [native code]\n}"
</pre>

<p>If the <code>toString()</code> method is called on a function created by the <code>Function</code> constructor, <code>toString()</code> returns the source code of a synthesized function declaration named "anonymous" using the provided parameters and function body.</p>

<p>It's also possible to explicitly get the string representation of a function using the <code>+</code> operator:</p>

<pre class="brush: js notranslate">function foo() { return 'bar' }
console.log(foo + ''); // "function foo() { return 'bar' }"</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Comparing_actual_source_code_and_toString_results">Comparing actual source code and toString results</h3>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Function</th>
   <th scope="col">Function.prototype.toString result</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>
    <pre class="notranslate">
function f(){}</pre>
   </td>
   <td>
    <pre class="notranslate">
"function f(){}"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
class A { a(){} }</pre>
   </td>
   <td>
    <pre class="notranslate">
"class A { a(){} }"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
function* g(){}</pre>
   </td>
   <td>
    <pre class="notranslate">
"function* g(){}"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
a =&gt; a</pre>
   </td>
   <td>
    <pre class="notranslate">
"a =&gt; a"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
({ a(){} }.a)</pre>
   </td>
   <td>
    <pre class="notranslate">
"a(){}"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
({ *a(){} }.a)</pre>
   </td>
   <td>
    <pre class="notranslate">
"*a(){}"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
({ [0](){} }[0])</pre>
   </td>
   <td>
    <pre class="notranslate">
"[0](){}"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
Object.getOwnPropertyDescriptor({
    get a(){}
}, "a").get</pre>
   </td>
   <td>
    <pre class="notranslate">
"get a(){}"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
Object.getOwnPropertyDescriptor({
    set a(x){}
}, "a").set</pre>
   </td>
   <td>
    <pre class="notranslate">
"set a(x){}"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
Function.prototype.toString</pre>
   </td>
   <td>
    <pre class="notranslate">
"function toString() { [native code] }"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
(function f(){}.bind(0))</pre>
   </td>
   <td>
    <pre class="notranslate">
"function () { [native code] }"</pre>
   </td>
  </tr>
  <tr>
   <td>
    <pre class="notranslate">
Function("a", "b")</pre>
   </td>
   <td>
    <pre class="notranslate">
"function anonymous(a\n) {\nb\n}"</pre>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-function.prototype.tostring', 'Function.prototype.toString')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.Function.toString")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Object.prototype.toString()")}}</li>
</ul>
